#!/usr/bin/perl

# output:
# video-url time-of-fetch views rate number-ratings comments favorited honors links
#
# separate output
# video-url time-of-fetch linking-url clicks
#
# separate output
# video-url time-of-fetch honor-string
#
# first time output
# url time-of-fetch author author-age authored-videos video-age category 

use HTML::Parser();
use Time::HiRes;

$currtime = 0;
$numratings = 0;
$views = -1;
$comments = 0;
$favorited = 0;
$honors = 0;
$links = 0;
$user = "";
$whenadded = "";
$category = "";
$ratings = 0;

sub start {
    $in1 = shift @_;
    $in2 = shift @_;
    $in3 = shift @_;
    
	
    if ($startStats || $startLinkRefs || $startChannel || $startVdetails) {
	$enclosed++;
    }

    if ($in1 eq "img") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /rating icn_star_empty_19x20/) {
		$numEmpty++;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"id"}) {
	    if ($$in2{"id"} =~ /defaultRatingMessage/) {
		$startRatings = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"id"}) {
	    if ($$in2{"id"} =~ /someStats/) {
		$startStats = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /channelIcon/) {
		$startChannel = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "span") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /viewCount/) {
		$startViews = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /statItem/) {
		$startLinkRefs = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($startLinkRefs) {
	if ($in1 eq "a") {
	    print OUT $$in2{"href"}, "\n";
	}
	return;
    }

    if ($in1 eq "a" && $startChannel) {
	$hlink = $$in2{"href"};
	if ($hlink =~ /\/user\//) {
	    $user = $hlink;
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /expand-content/) {
		$startVdetails = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "a") {
	$insideA = 1;
    }

    if ($in1 eq "span") {
	$insideSpan = 1;
    }
}

sub texthandle {
    $in1 = shift @_;

    if ($startVdetails) {
	if ($getAdded && $insideSpan) {
	    $whenadded = $in1;
	    $getAdded = 0;
	    return;

# 	    if ($in1 =~ /[^\d]*(\d.*) ago/) {
# 		$whenadded = $1;
# 		$getAdded = 0;
# 		return;
# 	    } else {
# 		print "error*************************\n";
# 		$getAdded = 0;
# 		return;
# 	    }

	}
	if ($getCategory && $insideA) {
	    $category = $in1;
	    $getCategory = 0;
	    return;
	}
	if ($in1 =~ /Added/) {
	    $getAdded = 1;
	} 
	if ($in1 =~ /Category/) {
	    $getCategory = 1;
	}
    }

    if ($startLinkRefs) {
	if ($in1 =~ /([^ ]*) clicks/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	    print OUT $ARGV[0], "\t", $currtime, "\t", $tempNum, "\t";
	}
	return;
    }

    if ($startViews) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$views = $tempNum;
	return;
    }

    if ($startRatings) {
	if ($in1 =~ /([^ ]*) rating/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	    $numratings = $tempNum;
	}
	return;
    }

    if ($startComments && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$comments = $tempNum;
	$startComments = 0;
	return;
    }

    if ($startFavorited) {
	if ($in1 =~ /([^ ]*) times/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	    $favorited = $tempNum;
	}
	$startFavorited = 0;
	return;
    }
    
    if ($startHonors && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$honors = $tempNum;
	$startHonors = 0;
	return;
    }

    if ($startLinks && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$links = $tempNum;
	$startLinks = 0;
	return;
    }

    if ($startStats) {
	if ($in1 =~ /Comments/) {
	    $startComments = 1;
	}
	if ($in1 =~ /Favorited/) {
	    $startFavorited = 1;
	}
	if ($in1 =~ /Honors/) {
	    $startHonors = 1;
	}
	if ($in1 =~ /Links/) {
	    $startLinks = 1;
	}
	return;
    }
}

sub end {
    $in1 = shift @_;
    $startRatings = 0;
    $startViews = 0;
    $insideA = 0;
    $insideSpan = 0;
    if ($startStats) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startStats = 0;
	}
    }
    if ($startLinkRefs) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startLinkRefs = 0;
	}
    }
    if ($startChannel) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startChannel = 0;
	}
    }
    if ($startVdetails) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startVdetails = 0;
	}
    }
}

$url = $ARGV[0];
$lastEpoch = $ARGV[1];
$lastViews = $ARGV[2];
$penultEpoch = $ARGV[3];
$penultViews = $ARGV[4];
$epochNum = $ARGV[5];
$recentOrPopular = $ARGV[6];


# threshold is 5 every epoch (of three hours) -- in case you want to perform exponential back-off.  This is currently turned off.
# if ($penultEpoch != -1 && (($lastViews - $penultViews)/($lastEpoch - $penultEpoch) < 5)) {
#     if (($epochNum - $lastEpoch) < 2*($lastEpoch - $penultEpoch)) {
# 	exit;
#     }
# }


# if ($penultEpoch != -1 && ($epochNum % 2 != 0) && $recentOrPopular == 2) {
#     exit;
# }

$viewDone = 0;
$numEmpty = 0;
$startStats = 0;
$p = HTML::Parser->new( api_version => 3,
                        start_h => [\&start, "tagname, attr, attrseq"],
                        end_h   => [\&end,   "tagname"],
                        text_h  => [\&texthandle, "dtext" ],
                        marked_sections => 1,
                        );

system("rm -f foo.html");
system("curl -b cookies.txt -s -k -o foo.html -m 30 " . $url);
open INFILE, "foo.html" or die $1;

if ($url =~ /http:\/\/youtube.com\/(.*)/) {
    $fname = $1;
    system("cp foo.html cache/" . $fname);
}

($seconds, $microseconds) = Time::HiRes::gettimeofday;

$currtime = $seconds;

open OUT, ">>clicksfile";

while ($line = <INFILE>) {
    $p->parse($line);
}
$ratings = 5 - $numEmpty;

# print "url ", $ARGV[0], "\n";
# print "time ", $currtime, "\n";
# print "category ", $category, "\n";
# print "ratings ", $ratings, "\n";
# print "numratings ", $numratings, "\n";
# print "views ", $views, "\n";
# print "comments ", $comments, "\n";
# print "favorited ", $favorited, "\n";
# print "honors ", $honors, "\n";
# print "links ", $links, "\n";
# print "user ", $user, "\n";
# print "when-added ", $whenadded, "\n";

if ($views != -1) {
    print $ARGV[0], "\t", $currtime, "\t", $epochNum, "\t", $category, "\t", $ratings, "\t", $numratings, "\t",
    $views, "\t", $comments, "\t", $favorited, "\t", $honors, "\t", $links, "\t", $user, "\t",
    $whenadded, "\n";
}

close OUT;

if ($recentOrPopular == 1) {
    open LINKSOUT, ">>recentout.txt";
    print LINKSOUT $url, "\t", $epochNum, "\t", $views, "\t", $lastEpoch, "\t", $lastViews, "\n";
    close LINKSOUT;
} else {
    if ($recentOrPopular == 2) {
	open LINKSOUT, ">>popularout.txt";
	print LINKSOUT $url, "\t", $epochNum, "\t", $views, "\t", $lastEpoch, "\t", $lastViews, "\n";
	close LINKSOUT;
    }
}
