#!/usr/bin/perl

# output:
# video-url time-of-fetch views rate number-ratings comments favorited honors links
#
# separate output
# video-url time-of-fetch linking-url clicks
#
# separate output
# video-url time-of-fetch honor-string
#
# first time output
# url time-of-fetch author author-age authored-videos video-age category 

use HTML::Parser();
use Time::HiRes;

$currtime = 0;
$numratings = 0;
$views = -1;
$comments = 0;
$favorited = 0;
$honors = 0;
$links = 0;
$user = "";
$whenadded = "";
$category = "";
$ratings = 0;

sub start {
    $in1 = shift @_;
    $in2 = shift @_;
    $in3 = shift @_;
    
	
    if ($startStats || $startLinkRefs || $startChannel || $startVdetails) {
	$enclosed++;
    }

    if ($in1 eq "img") {
	if (defined $$in2{"src"}) {
	    if ($$in2{"src"} =~ /star_empty_19x20/) {
		$numEmpty++;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"id"}) {
	    if ($$in2{"id"} =~ /defaultRatingMessage/) {
		$startRatings = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"id"}) {
	    if ($$in2{"id"} =~ /someStats/) {
		$startStats = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /channelIcon/) {
		$startChannel = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "span") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /viewCount/) {
		$startViews = 1;
	    }
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /statItem/) {
		$startLinkRefs = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($startLinkRefs) {
	if ($in1 eq "a") {
	}
	return;
    }

    if ($in1 eq "a" && $startChannel) {
	$hlink = $$in2{"href"};
	if ($hlink =~ /\/user\//) {
	    $user = $hlink;
	}
    }

    if ($in1 eq "div") {
	if (defined $$in2{"class"}) {
	    if ($$in2{"class"} =~ /expand-content/) {
		$startVdetails = 1;
		$enclosed = 1;
	    }
	}
    }

    if ($in1 eq "a") {
	$insideA = 1;
    }

    if ($in1 eq "span") {
	$insideSpan = 1;
    }
}

sub texthandle {
    $in1 = shift @_;

    if ($startVdetails) {
	if ($getAdded && $insideSpan) {
	    $whenadded = $in1;
	    $getAdded = 0;
	    return;

# 	    if ($in1 =~ /[^\d]*(\d.*) ago/) {
# 		$whenadded = $1;
# 		$getAdded = 0;
# 		return;
# 	    } else {
# 		print "error*************************\n";
# 		$getAdded = 0;
# 		return;
# 	    }

	}
	if ($getCategory && $insideA) {
	    $category = $in1;
	    $getCategory = 0;
	    return;
	}
	if ($in1 =~ /Added/) {
	    $getAdded = 1;
	} 
	if ($in1 =~ /Category/) {
	    $getCategory = 1;
	}
    }

    if ($startLinkRefs) {
	if ($in1 =~ /([^ ]*) clicks/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	}
	return;
    }

    if ($startViews) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$views = $tempNum;
	return;
    }

    if ($startRatings) {
	if ($in1 =~ /([^ ]*) rating/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	    $numratings = $tempNum;
	}
	return;
    }

    if ($startComments && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$comments = $tempNum;
	$startComments = 0;
	return;
    }

    if ($startFavorited) {
	if ($in1 =~ /([^ ]*) times/) {
	    $tempNum = $1;
	    $tempNum =~ s/,//g;
	    $favorited = $tempNum;
	}
	$startFavorited = 0;
	return;
    }
    
    if ($startHonors && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$honors = $tempNum;
	$startHonors = 0;
	return;
    }

    if ($startLinks && $insideA) {
	$tempNum = $in1;
	$tempNum =~ s/,//g;
	$links = $tempNum;
	$startLinks = 0;
	return;
    }

    if ($startStats) {
	if ($in1 =~ /Comments/) {
	    $startComments = 1;
	}
	if ($in1 =~ /Favorited/) {
	    $startFavorited = 1;
	}
	if ($in1 =~ /Honors/) {
	    $startHonors = 1;
	}
	if ($in1 =~ /Links/) {
	    $startLinks = 1;
	}
	return;
    }
}

sub end {
    $in1 = shift @_;
    $startRatings = 0;
    $startViews = 0;
    $insideA = 0;
    $insideSpan = 0;
    if ($startStats) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startStats = 0;
	}
    }
    if ($startLinkRefs) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startLinkRefs = 0;
	}
    }
    if ($startChannel) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startChannel = 0;
	}
    }
    if ($startVdetails) {
	$enclosed--;
	if ($enclosed == 0) {
	    $startVdetails = 0;
	}
    }
}

$url = $ARGV[0];

open INFILE, $url or die $1;

$url = "http://youtube.com/" . $ARGV[0];

# if ($url =~ /http:\/\/youtube.com\/(.*)/) {
#     $fname = $1;
#     system("cp foo.html cache/" . $fname);
# }

# ($seconds, $microseconds) = Time::HiRes::gettimeofday;

# $currtime = $seconds;

# open OUT, ">>clicksfile";

$p = HTML::Parser->new( api_version => 3,
                        start_h => [\&start, "tagname, attr, attrseq"],
                        end_h   => [\&end,   "tagname"],
                        text_h  => [\&texthandle, "dtext" ],
                        marked_sections => 1,
                        );

while ($line = <INFILE>) {
    $p->parse($line);
}

print $url, "\t", $category, "\t", $whenadded, "\n";

